Skip to main content
Typo tolerance helps users find relevant results even when their search queries contain spelling mistakes or typos, for example, typing phnoe instead of phone. You can configure the typo tolerance feature for each index.

enabled

Typo tolerance is enabled by default, but you can disable it if needed:
curl \
  -X PATCH 'MEILISEARCH_URL/indexes/movies/settings/typo-tolerance' \
  -H 'Content-Type: application/json' \
  --data-binary '{ "enabled": false }'
With typo tolerance disabled, Meilisearch no longer considers words that are a few characters off from your query terms as matches. For example, a query for phnoe will no longer return a document containing the word phone. In most cases, keeping typo tolerance enabled results in a better search experience. Massive or multilingual datasets may be exceptions, as typo tolerance can cause false-positive matches in these cases.

minWordSizeForTypos

By default, Meilisearch accepts one typo for query terms containing five or more characters, and up to two typos if the term is at least nine characters long. If your dataset contains seven, searching for sevem or sevan will match seven. But tow won’t match two as it’s less than 5 characters. You can override these default settings using the minWordSizeForTypos object. The code sample below sets the minimum word size for one typo to 4 and the minimum word size for two typos to 10.
curl \
  -X PATCH 'MEILISEARCH_URL/indexes/movies/settings/typo-tolerance' \
  -H 'Content-Type: application/json' \
  --data-binary '{
    "minWordSizeForTypos": {
      "oneTypo": 4,
      "twoTypos": 10
    }
  }'
When updating the minWordSizeForTypos object, keep in mind that:
  • oneTypo must be greater than or equal to 0 and less than or equal to twoTypos
  • twoTypos must be greater than or equal to oneTypo and less than or equal to 255
To put it another way: 0 ≤ oneTypo ≤ twoTypos ≤ 255. We recommend keeping the value of oneTypo between 2 and 8 and the value of twoTypos between 4 and 14. If either value is too low, you may get a large number of false-positive results. On the other hand, if both values are set too high, many search queries may not benefit from typo tolerance.
Typo on the first character
Meilisearch considers a typo on a query’s first character as two typos.
Concatenation
When considering possible candidates for typo tolerance, Meilisearch will concatenate multiple search terms separated by a space separator. This is treated as one typo. For example, a search for any way would match documents containing anyway.
For more about typo calculations, see below.

disableOnWords

You can disable typo tolerance for a list of query terms by adding them to disableOnWords. disableOnWords is case insensitive.
curl \
  -X PATCH 'MEILISEARCH_URL/indexes/movies/settings/typo-tolerance' \
  -H 'Content-Type: application/json' \
  --data-binary '{
    "disableOnWords": [
      "shrek"
    ]
  }'
Meilisearch won’t apply typo tolerance on the query term Shrek or shrek at search time to match documents.

disableOnAttributes

You can disable typo tolerance for a specific document attribute by adding it to disableOnAttributes. The code sample below disables typo tolerance for title:
curl \
  -X PATCH 'MEILISEARCH_URL/indexes/movies/settings/typo-tolerance' \
  -H 'Content-Type: application/json' \
  --data-binary '{ "disableOnAttributes": ["title"] }'
With the above settings, matches in the title attribute will not tolerate any typos. For example, a search for beautiful (9 characters) will not match the movie “Biutiful” starring Javier Bardem. With the default settings, this would be a match.

disableOnNumbers

You can disable typo tolerance for all numeric values across all indexes and search requests by setting disableOnNumbers to true:
curl \
  -X PATCH 'MEILISEARCH_URL/indexes/INDEX_NAME/settings/typo-tolerance' \
  -H 'Content-Type: application/json' \
  -H 'Authorization: Bearer MEILISEARCH_KEY' \
  --data-binary '{
    "disableOnNumbers": true
  }'
By default, typo tolerance on numerical values is turned on. This may lead to false positives, such as a search for 2024 matching documents containing 2025 or 2004. When disableOnNumbers is set to true, queries with numbers only return exact matches. Besides reducing the number of false positives, disabling typo tolerance on numbers may also improve indexing performance.

How typo tolerance works

Meilisearch uses a prefix Levenshtein algorithm to determine if a word in a document could be a possible match for a query term. The number of allowed typos is roughly equivalent to Levenshtein distance. The Levenshtein distance between two words M and P can be thought of as “the minimum cost of transforming M into P” by performing the following elementary operations on M:
  • Substitution of a character (for example, kittensitten)
  • Insertion of a character (for example, sitingsitting)
  • Deletion of a character (for example, saturdaysatuday)
By default, Meilisearch uses the following rules for matching documents. These rules apply per word, not for the whole query string:
  • If the query word is between 1 and 4 characters, no typo is allowed. Only documents containing words that start with or are of the same length as the query word are considered
  • If the query word is between 5 and 8 characters, one typo is allowed
  • If the query word contains more than 8 characters, a maximum of two typos is allowed
Meilisearch allows a maximum of 2 typos per word. Words with 3 or more typos will never match, regardless of word length or configuration. For example, saturday (8 characters) uses the second rule and matches with one typo:
  • saturday is accepted (exact match)
  • satuday is accepted (one typo)
  • sutuday is not accepted (two typos)
  • caturday is not accepted (a typo on the first letter counts as two typos)

Impact on the typo ranking rule

The typo ranking rule sorts search results by increasing number of typos on matched query words. Documents with 0 typos rank highest, followed by those with 1 and then 2 typos. The presence or absence of the typo ranking rule has no impact on the typo tolerance setting. However, disabling typo tolerance effectively also disables the typo ranking rule, because all returned documents will contain 0 typos.
  • Typo tolerance affects how lenient Meilisearch is when matching documents
  • The typo ranking rule affects how Meilisearch sorts its results
  • Disabling typo tolerance also disables the typo ranking rule